<?php
/* --------------------------------------------------------------
   ContentDeleter.inc.php 2019-07-31
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2019 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

/**
 * Class ContentDeleter
 */
class ContentDeleter implements ContentDeleterInterface
{
    /**
     * @var \CI_DB_query_builder
     */
    protected $queryBuilder;
    
    
    /**
     * ContentDeleter constructor.
     *
     * @param CI_DB_query_builder $query_builder
     */
    public function __construct(CI_DB_query_builder $query_builder)
    {
        $this->queryBuilder = $query_builder;
    }
    
    
    /**
     * Deletes the content data in database by id.
     *
     * @param $contentGroupId
     *
     * @return $this|\ContentDeleterInterface Same instance for chained method calls.
     */
    public function deleteById($contentGroupId)
    {
        $this->queryBuilder->query('DELETE FROM url_rewrites WHERE content_id IN (SELECT content_id FROM content_manager WHERE content_group ='
                                   . $contentGroupId . ')');
        
        $this->queryBuilder->query('DELETE FROM content_manager WHERE content_group = ' . $contentGroupId);
        
        return $this;
    }
}