<?php
/*--------------------------------------------------------------------------------------------------
    ThemeActivatorAdapter.php 2019-10-18
    Gambio GmbH
    http://www.gambio.de
    Copyright (c) 2019 Gambio GmbH
    Released under the GNU General Public License (Version 2)
    [http://www.gnu.org/licenses/gpl-2.0.html]
    --------------------------------------------------------------------------------------------------
 */

namespace Gambio\StyleEdit\Adapters;

use Gambio\GX\Services\System\ThemeSettings\ThemeSettingsService;
use Gambio\StyleEdit\Adapters\Interfaces\ThemeActivatorAdapterInterface;
use Gambio\StyleEdit\Core\BuildStrategies\Interfaces\SingletonStrategyInterface;
use StaticGXCoreLoader;

/**
 * Class ThemeActivatorAdapter
 * @package Gambio\StyleEdit\Adapters
 */
class ThemeActivatorAdapter implements ThemeActivatorAdapterInterface, SingletonStrategyInterface
{
    
    /**
     * @var ThemeSettingsService
     */
    protected $settings;
    
    
    /**
     * ThemeActivatorAdapter constructor.
     *
     * @param ThemeSettingsService $settings
     */
    public function __construct(ThemeSettingsService $settings)
    {
        $this->settings = $settings;
    }
    
    
    /**
     * @return static
     * @codeCoverageIgnore
     */
    public static function create(): self
    {
        return new self(StaticGXCoreLoader::getService('ThemeSettings'));
    }


    /**
     * @param string $themeId
     *
     * @return mixed
     * @throws \FileNotFoundException
     */
    public function activateTheme(string $themeId)
    {
        $this->settings->activateTheme($themeId);
    }
}